/*
This program is copy righted both in whole and in part. 
 
Terms of Agreement:   
 
   If you use this code (in whole or in part) you agree to be bound by the following terms.
 
1) You may use this code in your own programs (and may compile it into a program and distribute it in compiled format freely and with no charge
 Provide that:
  a) the program this code (in whole or in part) is used within is not of a commerical nature.
  b) no fee is charged for the distribution nor access to this code, nor programs which contain any part of this code.
2) Permission is granted to redistribute this code (for example on a web site) provided that it remains intact and unmodified..   
3) No warrenty, functionality, or suitability to any task is expressed, implied nor guarenteed by the author.
4) You agree to hold the author harmless, and assume all liability for any use of this code weither it is used in whole or in part.
5) This code is free.  But, any program you use it in, must contain this copy right notice and must also be equally free.
 
Failure to abide by these terms and conditions is a violation of copyright laws.
 
I am releasing this source code only to help others.  
Please see to it that this spirit is relected in any works that contain any part of this code.
 
Bjorn A. Lovoll
bjorn@lovoll.net
 
If you found it useful, drop me a line.  I would especially enjoy seeing any improvements you made to it.
*/

//--------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------//

//the includes, header files from which I use macro's, function/library calls, etc
#include "stdio.h"
#include "time.h"
#include "windows.h"  // I don't recall if windows,h is included in Borland C++ or not. So, this may not work in Borland C. 
					  // however, with Microsoft Visual C/C++ 6.0, this header file was neccessary
					  // for the millisecond timing routines that I used.

//prototyping the functions.
unsigned long getseed(void); // this is why the random number generator is perfectly random.  It gets initialized with a perfectly random seed, which can never repeat.
int getnum(int range);		 // this is the random number generator.  It generates a number between 1 and RANGE. Limited to 32768 as the upper max.
void usage(void);			 // this is the simplified internal documentation.
void ShellSort(int SortArray[], int SortElements); // this is slightly simplifed very fast shell sort, taylored to the needs of this program.
void sleep( clock_t wait_length);    // this is a simple sleep function.It sleeps for approx 1 millisecond.

//global variables
int number[10000];

//--------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------//

//-------------the-application-begins-below-this-line--------//
void main(int argc, char* argv[])
{
register int dicenum=1,counter=0, counter2;	//initilize the local variables.  registering loop/counters is faster.
int test=0, dicetype=6;						// do not register variables which do not need to be.
char holder[20];
float average=0;
	puts("\n\nDice Roller v1.0 copyright 2001 by Bjorn A. Lovoll\n");

//Initialize the randomizer
srand(getseed());

if ((argc < 2) || (argv[1][1] == '?'))  // Did they ask for usage "Dice /?"
	{	usage(); }						// This is the conventional method of asking for help with a console application,
										// and so should always be supported.
for (counter = 0 ; counter < argc ; counter++)					// parse the command line arguements.
{	if((argv[counter][1]>=97) && (argv[counter][1]>=97))		// use ascii values to see if it's lower case
		{	argv[counter][1] -=32;								//if it is, convert it to uppercase
		}
//--------------------------------------------------------------------------------------------------//

	if(argv[counter][1]=='D')														//\\ test for Dicetype \\//
		{	counter2=3;
			while (argv[counter][counter2] >='0' && argv[counter][counter2] <='9')	// test if it's a number
				{	holder[counter2-3]=argv[counter][counter2];						// keep adding the numbers to holder
					counter2++;														// as long as they are numbers
				}																	// when it hits a space, etc it stops.
		dicetype=atoi(holder);
		if( dicetype < 10001 && dicetype > 1)										// test Dice size for legal range
			{ test = 1;}
		else
			{
				puts("Dice size limit = 1 to 10000"); 
				dicetype =6;
			}
	}		

//--------------------------------------------------------------------------------------------------//

	for(counter2=0; counter2<sizeof(holder); counter2++)		//clear holder
		{holder[counter2]=NULL;}								//because the method of filling the field 
																//does not clear the variable.			
//--------------------------------------------------------------------------------------------------//


	if(argv[counter][1]=='N')														//\\ test for Dicenum \\//
		{	counter2=3;
			while (argv[counter][counter2] >='0' && argv[counter][counter2] <='9')	// test if it's a number
				{	holder[counter2-3]=argv[counter][counter2];						// keep adding the numbers to holder
					counter2++;														// as long as they are numbers
				}																	// when it hits a space, etc it stops.
		dicenum=atoi(holder);
		if( dicenum < 10001 && dicenum > 0)											// test Dice size for legal range
			{ test = 1;}
		else
			{
				puts("Number of Dice is limited = 1 to 10000"); 
				dicenum =6;
			}
		}

//--------------------------------------------------------------------------------------------------//

}


if (test == 0)				// did we find any legal command line arguements?  If not, go to usage.
		{	usage(); }

//--------------------------------------------------------------------------------------------------//
counter2=0;														// set our line counter to zero.
printf("Rolling %d  Dice that are %d sided\n",dicenum,dicetype);
printf("\n\nUnsorted: \n");
for (counter = 0 ; counter < dicenum ; counter++)
{	number[counter]=getnum(dicetype);							// get numbers from the random number generator
																// and put them in the array
	printf("%3d",number[counter]);								
	if( counter2>4 )											//Is this the 6th element in the line, if it is go to a new line
		{	printf("\n");
			counter2=0;											// reset the line counter
		}
	else
		{	if( counter < dicenum-1 )							// Is this the last number?
				{	printf(",");								// if it isn't, then put a comma in.
					counter2++;
				}
			if( counter2==3)									// more formatting, placing a space in the middle.
				{	printf(" ");	}	
		}
}
//--------------------------------------------------------------------------------------------------//
printf("\n\nSorted: \n");
ShellSort(number,dicenum);										//send the array to be sorted,
test=0;															//as well as telling the array the number of elements to sort.
counter2=0;
//--------------------------------------------------------------------------------------------------//
for (counter = 0 ; counter < dicenum ; counter++)		//print out the now sorted array.
{	printf("%3d",number[counter]);
	if( counter2>4 )
		{	printf("\n");
			counter2=0;
		}
	else
		{	if( counter < dicenum-1 )
				{	printf(",");
					counter2++;
				}
			if( counter2==3)
				{	printf(" ");	}	
		}
	average +=(float)number[counter];			// get a sum of the numbers generated
}												// this is cast to a float to avoid division rounding errors.	
//--------------------------------------------------------------------------------------------------//
printf("\n\nTotal: %.0f   ",average);			// this is a float, but I did not want decimals in the output here.
average /=dicenum;								// average = average/dicenum
printf("\tAverage: %6.3f\n",average);			// this is a float, and I do want 3 decimal places in the output here.

//--------------------------------------------------------------------------------------------------//
puts("");			//just a formatting thing.
  exit(0);
}

//--------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------//

int getnum(int range)
{	
//  Number generator.  Gets a number from 1 to range.
	int d;
	d=(rand() % range)+1; 
	return(d);			  
	/*
	Even though is a fairly basic random number generator, it will generate a completely random number because the seed is
	always a unique number.  The seed is the entry point into the number table for the rand function.  With a random entry
	point it will produce a random number.  If you do not have a random seed, this is simply not possible.
	The only possible random seed is a time derivative.  Even with millisecond granularity, care must be taken to not 
	reinitilize the rand function with an identical seed.  I do this quite simply, but effectively.  Please review
	the getseed function for spedifics.

	There is one draw back to this quick and easy random number generator.
	rand is limted to MAX_RAND, or 32768 as the largest number it can generate on a single run.
	There are two methods you can work around this.  Both have compromises.
	mynumber=2*getnum(range) or mynumber=getnum(range)+getnum(range)
	Method #1 has the limitation of not as much granularity, but it is a 100% random number in the range.
	Method #2 has the granularity, but it bellcurves the distribution of the numbes to be more center weighted.
	*/
}

//--------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------//

void ShellSort(int SortArray[], int SortElements)
{// A simple yet very fast Shell sort.  On average 4 times faster then a bubble sort.
    register int counter, step, increment; //this improves speed for the counters
    int temp;	// do not register a variable unless you need to.
    for ( increment = SortElements/2; increment > 0; increment /= 2) 
		//divides the array into sections, each loop including half again the area 
		{	for (counter = increment; counter < SortElements; counter++) 
				{   temp = SortArray[counter]; 
					step = counter;                                    //Set the shell 
					while ((step >= increment) && (temp < SortArray[step - increment])) 
						{	SortArray[step] = SortArray[step - increment]; 
							step -= increment;                            //the decrement 
						} 
					SortArray[step] = temp; 
				} 
		} 
}  //for more on Shellsorts, please read Algorithms in C by Robert Sedgewick.

//--------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------//

void sleep( clock_t wait_length )
{  // do nothing loop based on time.  Used to control timing on very fast computers.
   clock_t stop_time;
   stop_time = wait_length + clock();
   while( stop_time > clock() )
      ;
}

//--------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------//

unsigned long getseed()
{
	unsigned long seed;
//getting a truely random seed based on time
 
//Initialize the randomizer
 
 /* sleeping for approx. 1 millisecond to ensure a 100% random seed .
    This is neccessary on very fast computers since they can loop in less then 1 millisecond.
    to wait for 1 second delete " / 999 "
    to wait for 5 seconds change, change (clock_t)1 to (clock_t)5 and delete " / 999 " */
	sleep( (clock_t)1 * ( CLOCKS_PER_SEC / 999 ) );
 
	SYSTEMTIME st	= {0}; 
	GetSystemTime(&st); 
 
 //using a unsigned int, since otherwise it converts the seed to a signed int.
 seed= ( time((time_t *) NULL) * CLOCKS_PER_SEC )+st.wMilliseconds;
 seed++; // incrementing the seed by 1 in case of very fast loops which reinitialize
/* 
The seed is incremented in two different ways to solve two different problems.
The wait is for fast computers looping the NPC generator in a script.
The increment (++) is so the the randomizer can be reinitilized during the execution of the generator.
*/
return(seed);
}

//--------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------//

void usage(void)
{	char command[80];
	
	strcpy(command,"cls");	// this is included to show how to use the system() function to invoke system/shell commands 
	system(command);		// such as cd, md, copy, etc.  To put variables in command, see makepc for useage of sprintf.

	puts("\n\nDice Roller v1.0 copyright 2001 by Bjorn A. Lovoll\n");

	puts("Usage: DOSDICE [/D:#] [/N:#]");
	puts("\n/D: (or /d:) = dice size");
	puts(" for a 6 sided dice, enter /D:6. Any number from 2 to 10000 may be used");
	puts("\n/N: (or /N:) = dice number");
	puts(" To get 6 numbers enter in /N:6. Any number from 1 to 10000 may be used");
	puts("\nAny combination of switches in any order may be invoked. ");
	puts("Any switch not invoked defaults to: d=6, n=1");
	puts("You must specify at least 1 valid switch [/D, or /N].");
	puts("\nExamples:\n");
	puts("Dice  /D:6 /N:4 = roll a 6 sided dice 4 times");
	puts("Dice  /D:4 /N:6 = roll a 4 sided dice 6 times");
	puts("Dice  /N:4 = roll a 6 sided dice 4 times");
	puts("Dice  /D:4 = roll a 4 sided dice 1 time");
	puts("\nThis program is freeware.  If you like it, use it guilt free.");
	puts("For more detailed info and help, please read the dice.txt file");
exit(1);
}

//--------------------------------------------------------------------------------------------------//
//--------------------------------------------------------------------------------------------------//